var conv = require('../convert-hex')
  , expect = require('chai').expect

describe('- bytesToHex', function() {
  describe('> when an array of bytes are input', function() {
    it('should convert to a hex string', function() {
      var bytes = [0x34, 0x55, 0x1, 0xDF]
      expect(conv.bytesToHex(bytes)).to.equal("345501df")
    })
  })

  /*describe('> when an ArrayBuffer / DataView is input', function() {
    var ui8 = new Uint8Array(4)
    ui8[0] = 0x34
    ui8[1] = 0x55
    ui8[2] = 0x1
    ui8[3] = 0xDF

    expect(conv.bytesToHex(ui8)).to.equal("345501df")
    expect(conv.bytesToHex(ui8.buffer)).to.equal("345501df")
    expect(conv.bytesToHex(new DataView(ui8.buffer))).to.equal("345501df")

    var ui16 = new Uint16Array(2)
    ui16[0] = 0x5534
    ui16[1] = 0xDF01
    expect(conv.bytesToHex(ui16)).to.equal("345501df")

    var ui32 = new Uint32Array(1)
    ui32[0] = 0xDF015534
    expect(conv.bytesToHex(ui32)).to.equal("345501df")
  })*/
})

describe('- hexToBytes', function() {
  describe('> when a hex string is input', function() {
    it('should convert to an array of bytes', function() {
      var hex = "34550122DF"
      expect(conv.hexToBytes(hex).join(',')).to.equal('52,85,1,34,223')
    })
  })

  describe('> when the hex string has an odd number of characters', function() {
    it('should throw an error', function() {
      //this is because the forks and the bitcoinjs implementations differ
      //need to check on this again

      var hex = "F34550122DF"
      var errCount = 0
      try {
        conv.hexToBytes(hex)
      } catch (e) { errCount += 1}

      hex = "34550122DFF"
      try {
        conv.hexToBytes(hex)
      } catch (e) { errCount += 1}

      expect(errCount).to.equal(2)
    })
  })

  describe('> when the hex string contains the "0x" prefix', function() {
    it('should convert to an array of bytes', function() {
      var hex = "0x34550122DF"
      expect(conv.hexToBytes(hex).join(',')).to.equal('52,85,1,34,223')
    })
  })
})